CON
  _clkmode      = xtal1 + pll16x         'Use low crystal gain, wind up 16x               
  _xinfreq      = 5_000_000              'External 5 MHz crystal on XI & XO

PUB Main

  InSync(16, clkfreq / 1000, 2000)       'Toggle P16 at exactly 1,000 Hz for 2,000 cycles

PRI InSync(Pin, Duration, Count) | Time
{{Toggle Pin at each Duration window for Count cycles.  This Duration delay is based on
an absolute reference point that never changes, the 'Time := cnt' line, so loop overhead
is automatically accounted for on each iteration; this means the '!outa[Pin]' event occurs
exactly at each duration window.}}
  
  dira[Pin]~~                            'Set Pin to output 
  Time := cnt                            'Determine reference moment
  repeat Count * 2                       'Loop Count * 2 times...
    waitcnt(Time += Duration)            '  Delay for some time
    !outa[Pin]                           '  Toggle I/O pin 
  