CON
  _clkmode      = xtal1 + pll16x         'Use low crystal gain, wind up 16x               
  _xinfreq      = 5_000_000              'External 5 MHz crystal on XI & XO

PUB Main

  OutOfSync(16, clkfreq / 1000, 2000)    'Toggle P16 at roughly 1,000 Hz for 2,000 cycles

PRI OutOfSync(Pin, Duration, Count)
{{Toggle Pin, then delay for Duration, for Count cycles.  Such a fixed delay, without
adjustment for loop-time, makes event timing experience cumulative errors; event trigger
moments are out-of-synch with the ideal duration window.}}
  
  dira[Pin]~~                            'Set Pin to output                         
  repeat Count * 2                       'Loop Count * 2 times...
    !outa[Pin]                           '  Toggle I/O pin
    waitcnt(Duration + cnt)              '  Delay for some time
  